function [] = Amplitude_Neural_Network(modScheme)
%AMPLITUDE_NEURAL_NETWORK Summary of this function goes here
%   Detailed explanation goes here

layers = [
    imageInputLayer([500 1 1])
    %sequenceInputLayer(4,'Name','InputData') 
    %Intermediary Part 1
    
    %First Convolutional Layer
    convolution2dLayer([20 1], 40,"Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    %Second Convolutional Layer
    convolution2dLayer([20 1], 30, "Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    convolution2dLayer([10 1], 20,"Stride",[2 1], "Padding", [6 0 0 0])
    batchNormalizationLayer
    reluLayer  
    
    convolution2dLayer([10 1], 20,"Stride",[2 1], "Padding", [6 0 0 0])
    batchNormalizationLayer
    reluLayer  
    
    convolution2dLayer([10 1], 20,"Stride",[2 1], "Padding", [6 0 0 0])
    batchNormalizationLayer
    
    
    fullyConnectedLayer(11)
    softmaxLayer
    classificationLayer];
analyzeNetwork(layers);

if modScheme == "ASK"
    load('ASK_Amplitude_TrainData.mat');
elseif modScheme == "FSK"
    load('FSK_Amplitude_TrainData.mat');
elseif modScheme == "PSK"
    load('PSK_Amplitude_TrainData.mat');
else
    disp('Illegal modScheme. Aborting!')
    return
end

%IF FFT
%for i=1:length(XTrain)
%    temp = fft(XTrain(:,:,1,i));
%    XTrain(:,:,1,i) = abs(temp);
%    XTrain(:,:,2,i) = unwrap(angle(temp));
%end

%options = trainingOptions('sgdm','MaxEpochs',500,'InitialLearnRate',1e-3,'Verbose',0,'Plots','training-progress');
options = trainingOptions('adam','MaxEpochs',100,'Verbose',0,'Plots','training-progress');
net = trainNetwork(XTrain, YTrain,layers, options);
%genFunction(net,'cnetcode2','MatrixOnly','yes');

save('Amplitude_TrainedNetwork','net');


end

