function [] = ASK_NoisyFull_Neural_Network(modScheme)
%ASK_NOISYFULL_NEURAL_NETWORK Summary of this function goes here
%   Detailed explanation goes here
layers = [
    imageInputLayer([1000 1 1])
    %sequenceInputLayer(4,'Name','InputData') 
    %Intermediary Part 1
    
    convolution2dLayer([200 1], 10,"Stride",[1 1], "Padding", [20 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    convolution2dLayer([50 1], 10, "Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer

    convolution2dLayer([20 1], 5, "Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer
    
    convolution2dLayer([20 1], 5, "Stride",[2 1], "Padding", [10 0 0 0])
    batchNormalizationLayer
    reluLayer
    

    
    %fullyConnectedLayer(100)
    fullyConnectedLayer(8)
    softmaxLayer
    classificationLayer];
analyzeNetwork(layers);

if modScheme == "ASK"
    load('ASK_Full_TrainData')
elseif modScheme == "FSK"
    load('FSK_Full_TrainData')
elseif modScheme == "PSK"
    load('PSK_Full_TrainData')
else
    disp('Illegal modScheme. Aborting!')
    return
end

%load('PSK_0SNR_Full_10bs_TrainData.mat');
%IF FFT:
%for i = 1:length(XTrain)
%    temp = fft(XTrain(:,:,1,i));
%    XTrain(:,:,1,i) = abs(temp);
%    XTrain(:,:,2,i) = unwrap(angle(temp));
%end

%options = trainingOptions('sgdm','MaxEpochs',500,'InitialLearnRate',1e-3,'Verbose',0,'Plots','training-progress');
options = trainingOptions('adam','MaxEpochs',100,'Verbose',0,'Plots','training-progress');
net = trainNetwork(XTrain, YTrain,layers, options);
save('Full_TrainedNetwork','net');

end

