function [] = Lengths_Classify(modScheme)
%LENGTHS_CLASSIFY Summary of this function goes here
%   Detailed explanation goes here

if modScheme == "ASK"
    load('ASK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork.mat');
    load('ASK_0SNR_lengths_10bs_ClassifyData.mat');
elseif modScheme == "FSK"
    load('FSK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork.mat');
    load('FSK_0SNR_lengths_10bs_ClassifyData.mat');
elseif modScheme == "PSK"
    load('PSK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork.mat');
    load('PSK_0SNR_lengths_10bs_ClassifyData.mat');
else
    disp("Illegal modulation scheme. Aborting")
    return
end
%load('PSK_0SNR_lengths_50b10_1period_sgdm_TrainedNetwork.mat');
%load('PSK_0SNR_lengths_10bs_ClassifyData.mat');

%IF FFT
%fftinitTime = tic;
%for i = 1:length(XTest)
%    temp = fft(XTest(:,:,1,i));
%    XTest(:,:,1,i) = abs(temp);
%    XTest(:,:,2,i) = unwrap(angle(temp));
%end
%fftStopTime = toc(fftinitTime)

initTime = tic;
YPred = classify(net,XTest);
stopTime = toc(initTime)
stopTime_perinstance = stopTime/ length(YPred)
accuacy = sum(YPred == YTest)/numel(YTest)

%[YTest(:,:) YPred(:,:)]




comparison_table = zeros(27,27);
comparison_table(1,:) = [0 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25];
comparison_table(:,1) = [0 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25];

for i= 1:length(YPred)
    yPred_i = 0;
    yTest_i = 0;
    for test_index = 0:25
        if YTest(i) == categorical(test_index)%categorical(cellstr(int2str(test_index)))
            yTest_i = test_index+2;
        end
    end
    
    for pred_index = 0:25
        if YPred(i) == categorical(pred_index)%categorical(cellstr(int2str(pred_index)))
            yPred_i = pred_index+2;
        end
    end
    comparison_table(yTest_i,yPred_i) = comparison_table(yTest_i,yPred_i)+1;
end

accuracy_1off = comparison_table(2,2) + comparison_table(2,3);
for i=3:26
    accuracy_1off = accuracy_1off + comparison_table(i,i-1) + comparison_table(i,i)+ comparison_table(i,i+1);
end
accuracy_1off = accuracy_1off + comparison_table(27,26) + comparison_table(27,27);

accuracy_1off = accuracy_1off / length(YTest)

save('LENGTH_CLASSIFY_RESULTS','comparison_table');



end

